/*
* Copyright 2009-2010, Andrew Barry
*
* some small improvements Copyright 2012, Hans Paijmans (paai)
* This file is part of MakerScanner.
*
* MakerScanner is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License (Version 2, June 1991) as published by
* the Free Software Foundation.
*
* MakerScanner is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef ACTIVESTEREOAPP_H
#define ACTIVESTEREOAPP_H

#include <wx/app.h>

// next two lines by paai
#include <wx/wxprec.h>
#include <wx/cmdline.h>
 

#ifndef WX_PRECOMP
       #include <wx/wx.h>
#endif


     wxString paai_filename;
     wxString pointcloudFilename;
     wxString version;
     double DISPARITY_DISTANCE;
     long thresholdPixelValue;
     long pedestal_height,background_depth;
     double brightnessFilterValue;
bool verbose,paai_help,debug,no_background;
     long rainbow_factor;
     int distance_array[1000]; // 480 should be sufficient
     int red_array[1000]; // 480 should be sufficient
     int blue_array[1000]; // 480 should be sufficient
     int green_array[1000]; // 480 should be sufficient

static const wxCmdLineEntryDesc g_cmdLineDesc [] =
{
     { wxCMD_LINE_SWITCH, wxT("h"), wxT("help"),          wxT("displays help") },
     { wxCMD_LINE_SWITCH, wxT("v"), wxT("verbose"),       wxT("verbose") },
     { wxCMD_LINE_SWITCH, wxT("D"), wxT("Debug"),         wxT("debug") },
     { wxCMD_LINE_SWITCH, wxT("n"), wxT("no_background"), wxT("no_background") },

     { wxCMD_LINE_OPTION, wxT("N"), wxT("no_background"), wxT("no_background")                    ,wxCMD_LINE_VAL_STRING},
     { wxCMD_LINE_OPTION, wxT("d"), wxT("distance"),      wxT("distance between laser and camera"),wxCMD_LINE_VAL_STRING},
     { wxCMD_LINE_OPTION, wxT("t"), wxT("treshold"),      wxT("laser pixel treshold")             ,wxCMD_LINE_VAL_STRING},
     { wxCMD_LINE_OPTION, wxT("b"), wxT("brightness"),    wxT("normal pixel treshold")            ,wxCMD_LINE_VAL_STRING},
     { wxCMD_LINE_OPTION, wxT("p"), wxT("pedestal"),      wxT("pedestal heigth for cut-off")      ,wxCMD_LINE_VAL_STRING},
     { wxCMD_LINE_OPTION, wxT("r"), wxT("rainbow"),       wxT("shading for depth")                ,wxCMD_LINE_VAL_STRING},

     { wxCMD_LINE_PARAM,wxT("filename"),wxT("filename2"),wxT("filename"),wxCMD_LINE_VAL_STRING, wxCMD_LINE_PARAM_OPTIONAL},
    
     { wxCMD_LINE_NONE }
};

class ActiveStereoApp : public wxApp
{
    public:
        virtual bool OnInit();

	//	wxString paai_filename;

// next two lines by paai

    virtual void OnInitCmdLine(wxCmdLineParser& parser);
    virtual bool OnCmdLineParsed(wxCmdLineParser& parser);

 private:
    bool silent_mode;
    //    bool paai_help,debug,no_background;
    bool read_file;
    

};
DECLARE_APP(ActiveStereoApp)

#endif // ACTIVESTEREOAPP_H
